package com.codigoparallevar.minicards.bridge.helpers;

import android.net.ConnectivityManager;
import android.net.Network;
import android.os.Build;

import androidx.annotation.RequiresApi;

@RequiresApi(api = Build.VERSION_CODES.LOLLIPOP)
class WifiNetworkCallbackReceiver extends ConnectivityManager.NetworkCallback {
    private final StatusStreamer streamer;

    public WifiNetworkCallbackReceiver(StatusStreamer statusStreamer) {
        this.streamer = statusStreamer;
    }

    @Override
    public void onAvailable(Network network) {
        super.onAvailable(network);
        this.streamer.onWifiNetworkConnected(network);
    }

    @Override
    public void onUnavailable() {
        super.onUnavailable();
        this.streamer.onWifiNetworkDisconnected();
    }

    @Override
    public void onLost(Network network) {
        super.onLost(network);
        this.streamer.onWifiNetworkDisconnected();
    }
}
