package com.codigoparallevar.minicards.types;

import com.codigoparallevar.minicards.SignalListenerManager;
import com.codigoparallevar.minicards.types.connectors.input.AnyInputConnector;
import com.codigoparallevar.minicards.types.connectors.input.BooleanInputConnector;
import com.codigoparallevar.minicards.types.connectors.input.ImageInputConnector;
import com.codigoparallevar.minicards.types.connectors.input.SignalInputConnector;
import com.codigoparallevar.minicards.types.connectors.input.StringInputConnector;
import com.codigoparallevar.minicards.types.functional.Tuple2;
import com.programaker.api.ProgramakerApi;

public interface PartGrid {
    Selectable getPartOn(int x, int y);
    ProgramakerApi getApi();
    SignalListenerManager getListenerManager();

    SignalInputConnector getSignalInputConnectorOn(int x, int y);
    BooleanInputConnector getBooleanInputConnectorOn(int x, int y);
    AnyInputConnector getAnyInputConnectorOn(int x, int y);
    StringInputConnector getStringInputConnectorOn(int xEnd, int yEnd);
    ImageInputConnector getImageInputConnectorOn(int xEnd, int yEnd);

    Tuple2<Integer,Integer> getCenteredOn();

    void update();
}
