package com.codigoparallevar.minicards.types.connectors.input;

import com.codigoparallevar.minicards.types.Dropper;
import com.codigoparallevar.minicards.types.Part;
import com.codigoparallevar.minicards.types.Selectable;
import com.codigoparallevar.minicards.types.connectors.Wiring.Wire;
import com.codigoparallevar.minicards.types.wireData.WireDataType;

public interface InputConnector<T extends WireDataType, T1 extends InputConnector<T, T1>>
        extends Selectable, Dropper {

    void updatePosition(int x, int y);

    int getX();

    int getY();

    void addAttachment(Wire<T, T1> wire);

    Part getPart();

    String getId();

    void send(T data);

    void wireUnlinked(Wire wire);
}
