package com.codigoparallevar.minicards.types.functional;

public class Tuple2<T1, T2> {
    public final T1 item1;
    public final T2 item2;

    public Tuple2(T1 item1, T2 item2) {
        this.item1 = item1;
        this.item2 = item2;
    }

    @Override
    public int hashCode() {
        int hash1 = this.item1 == null ? 1 : this.item1.hashCode();
        int hash2 = this.item2 == null ? 2 : this.item2.hashCode();

        return hash1 ^ hash2;
    }

    @Override
    public boolean equals(Object obj) {
        if (!(obj instanceof Tuple2)) {
            return false;
        }

        Tuple2 other = (Tuple2) obj;
        if (other.item1 == null) {
            if (this.item1 != null) {
                return false;
            }
        }
        else {
            if (!other.item1.equals(this.item1)) {
                return false;
            }
        }

        if (other.item2 == null) {
            if (this.item2 != null) {
                return false;
            }
        }
        else {
            if (!other.item2.equals(this.item2)) {
                return false;
            }
        }
        return true;
    }
}
