package com.programaker.api.data

import android.util.Log
import org.json.JSONArray
import org.json.JSONObject
import java.util.*

class ProgramakerCustomBlockArgument(
        val type: String?,
        val default_value: String?,
        // val class: String,
        val callback: String?
) {
    var bridge_id: String? = null

    fun serialize():  JSONObject {
        val serialized = hashMapOf<String, String?>(
                "type" to type,
                "default_value" to default_value,
                "callback" to callback,
                "bridge_id" to bridge_id
        )

        return JSONObject(serialized as Map<*, *>)
    }

    fun getComputedType(): String? {
        if (callback != null && callback != "null") {
            return "ENUM";
        }
        else {
            return type;
        }
    }

    companion object {
        @JvmStatic
        fun deserialize(arguments: JSONArray?): List<ProgramakerCustomBlockArgument> {
            if (arguments == null) {
                return listOf();
            }
            val results: MutableList<ProgramakerCustomBlockArgument> = LinkedList()

            var i = 0;
            while (i < arguments.length()) {
                val obj = arguments.getJSONObject(i)
                if (obj == null) {
                    Log.e("PMCustomBlockArgument", "Looped into a null value!?")
                }
                else {
                    results.add(deserialize(obj))
                }

                i += 1;
            }

            return results
        }

        @JvmStatic
        fun deserialize(arguments: JSONObject): ProgramakerCustomBlockArgument {
            val type: String? = arguments.optString("type")
            val default_value: String? = arguments.optString("default_value")
            val callback: String? = arguments.optString("callback")
            val bridge_id: String? = arguments.optString("bridge_id")

            val arg = ProgramakerCustomBlockArgument(type, default_value, callback)
            arg.bridge_id = bridge_id
            return arg
        }
    }

}
