package com.programaker.api.data

import com.programaker.api.optGet
import java.util.*

class ProgramakerCustomBlockArgumentValue (
        val id: String,
        val name: String
) {
    companion object {
        @JvmStatic
        fun deserializeList(value: Object): List<ProgramakerCustomBlockArgumentValue> {
            if (value is Map<*, *>) {
                return deserialize(value as Map<*, *>)
            } else if (value is List<*>) {
                return deserialize(value as List<*>)
            } else {
                throw IllegalArgumentException("Error deserializing: $value")
            }
        }

        @JvmStatic
        fun deserialize(value: Map<*, *>): List<ProgramakerCustomBlockArgumentValue> {
            val results = LinkedList<ProgramakerCustomBlockArgumentValue>()
            for (entry in value.asIterable()) {
                var value = entry.value.toString()
                if (entry.value is Map<*, *>) {
                    if ((entry.value as Map<String, *>).containsKey("name")) {
                        value = (entry.value as Map<*, *>)["name"].toString()
                    }
                }

                results.add(ProgramakerCustomBlockArgumentValue(entry.key.toString(), value))
            }

            return results
        }

        @JvmStatic
        fun deserialize(value: List<*>): List<ProgramakerCustomBlockArgumentValue> {
            val results = LinkedList<ProgramakerCustomBlockArgumentValue>()
            for (entry in value) {
                if (entry is Map<*,*>) {
                    var name = (entry as Map<String, *>).optGet("name")
                    var id = (entry as Map<String, *>).optGet("id")
                    
                    if (name == null && id == null) {
                        throw IllegalArgumentException("Error deserializing: $entry")
                    }
                    else if (name == null) {
                        name = id
                    }
                    else if (id == null) {
                        id = name
                    }

                    results.add(ProgramakerCustomBlockArgumentValue(id.toString(), name.toString()))
                }
                else {
                    throw IllegalArgumentException("Error deserializing: $entry")
                }
            }

            return results
        }
    }
}
