package com.programaker.api.data

import org.json.JSONObject

class ProgramakerCustomBlockSubkeyDefinition(
        val type: String,
        val value: String
) {
    fun serialize(): JSONObject {
        return JSONObject(hashMapOf(
                "type" to type,
                "value" to value
        ) as Map<*, *>)
    }

    companion object {
        @JvmStatic
        fun deserialize(subkey: JSONObject?): ProgramakerCustomBlockSubkeyDefinition? {
            if (subkey == null) {
                return null;
            }

            return ProgramakerCustomBlockSubkeyDefinition(
                    subkey.getString("type"),
                    subkey.getString("value"))
        }
    }

}
