package com.programaker.api.data.api_results

import com.google.gson.*
import com.programaker.api.data.ProgramakerCustomBlock
import java.lang.reflect.Type
import java.util.*

internal class ProgramakerGetCustomBlocksResultTypeAdapter : JsonSerializer<ProgramakerGetCustomBlocksResult?>, JsonDeserializer<ProgramakerGetCustomBlocksResult> {
    var gson = Gson()
    override fun serialize(customBlock: ProgramakerGetCustomBlocksResult?, typeOfT: Type, context: JsonSerializationContext): JsonElement {
        throw NotImplementedError()
    }

    @Throws(JsonParseException::class)
    override fun deserialize(element: JsonElement, typeOfT: Type, context: JsonDeserializationContext): ProgramakerGetCustomBlocksResult {
        val json = element.asJsonObject
        val bridges: MutableList<ProgramakerBridgeCustomBlockResult> = LinkedList()

        for ((bridgeId, value1) in json.entrySet()) {

            val blocks: MutableList<ProgramakerCustomBlock> = LinkedList()

            for (value in value1.asJsonArray) {
                val block = gson.fromJson(value, ProgramakerCustomBlock::class.java)
                block.bridge_id = bridgeId
                if (block.arguments != null) {
                    for (arg in block.arguments) {
                        arg.bridge_id = bridgeId
                    }
                }
                blocks.add(block)
            }

            val bridge = ProgramakerBridgeCustomBlockResult(bridgeId, blocks)

            bridges.add(bridge)
        }

        return ProgramakerGetCustomBlocksResult(bridges)
    }
}